/* 
 * $Id: GLSDDocumentModuleChecker.h 23339 2010-01-29 12:32:18Z ozawa $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 23339 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___GLSDDOCUMENTMODULECHECKER_H
#define ___GLSDDOCUMENTMODULECHECKER_H

#include "modules/XDTPChecker.h"

namespace XDTP {

class GLSDDocumentModuleChecker : public XDTPChecker
{
public:
	GLSDDocumentModuleChecker();
	virtual ~GLSDDocumentModuleChecker();

    /**
     * 文書モジュールの正当性をチェックします。
     * 
     * @param aDocument ロードした直後のXMLファイル
     * @return 変換処理を中断する場合は false を戻します。
     */
    virtual bool checkFormat(xmlDocPtr aDocument);

private:
    /**
     * aliasエレメントの確認。
     * 
     * @param aDocument
     *            XMLのルートノード
     */
    bool checkAlias(xmlNodePtr aDocumentRoot);

	/**
	 * list要素の構造をチェックします。
     * 
     * @param aNode 親list要素
     * @return 変換処理を中断する場合は false を戻します。
	 */
	bool checkFormat_list(xmlNodePtr aNode);
};

};

#endif
