<?xml version="1.0" encoding="EUC-JP"?>

<!--
 * $Id: GLSDocumentModule.xsl 20262 2009-01-26 08:13:14Z ozawa $
 *
 * Copyright (c) 2003- ONGS Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
-->

<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

 <xsl:output method="html" encoding="EUC-JP" indent="yes"
  doctype-public="-//W3C//DTD HTML 4.0 //EN"/>

<!-- إåʬ -->
 <xsl:template match="/document/docgroup">
  <html>
  <head>
   <meta content="text/css" http-equiv="Content-Style-Type"/>
   <title>
    <xsl:for-each select="docinfo/title[1]/p">
	 <xsl:apply-templates/>
    </xsl:for-each>
   </title>
   <style type="text/css">
    <xsl:comment>
     <xsl:call-template name="style_text_css"/>
    </xsl:comment>
   </style>
  </head>
  <body id="@id">
   <xsl:apply-templates/>
  </body>
  </html>
 </xsl:template>

<!-- 륷Ȥλ -->
 <xsl:template name="style_text_css">
  <xsl:text>
   body {
     max-width: 210mm;
     width: 95%;
     margin-left: auto;
     margin-right: auto;
     padding: 0px;
     font-size: 11pt;
   }
   h1.document-title {
     text-align: center;
   }
   h2 {
     margin: 15mm 0mm 2mm 0mm;
   }
   h3 {
     margin: 12mm 0mm 1mm 0mm;
   }
   h4 {
     margin: 9mm 0mm 1mm 0mm;
   }
   h5 {
     margin: 6mm 0mm 0mm 0mm;
   }
   h6 {
     margin: 3mm 0mm 0mm 0mm;
   }
   p {
     text-indent: 1.0em;
     line-height: 1.5em;
   }
  </xsl:text>
 </xsl:template>

<!-- ƬɥȾ -->
 <xsl:template match="/document/docgroup/docinfo">
  <xsl:for-each select="title[1]/p">
   <h1 class="document-title"><xsl:apply-templates/></h1>
  </xsl:for-each>
  <div>
   <xsl:call-template name="docinfo"/>
  </div>
 </xsl:template>

 <xsl:template match="/document/docgroup//docgroup/docinfo">
  <xsl:choose>
   <xsl:when test="6 >= count(ancestor::docgroup)">
    <xsl:call-template name="title">
     <xsl:with-param name="docgroup_level"><xsl:value-of select="count(ancestor::docgroup)"/></xsl:with-param>
    </xsl:call-template>
   </xsl:when>

   <xsl:otherwise>
    <xsl:call-template name="title">
     <xsl:with-param name="docgroup_level">6</xsl:with-param>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="title">
  <xsl:param name="docgroup_level"/>
  <xsl:variable name="startnumber"><xsl:value-of select="/document/docgroup/docinfo/initialnumber[1]/text()"/></xsl:variable>
  <xsl:variable name="basenumber"><xsl:number level="multiple" count="/document/docgroup//docgroup"/></xsl:variable>

  <!-- ֹ -->
  <xsl:for-each select="title[1]/p">
   <xsl:element name="h{$docgroup_level}">
    <xsl:choose>
     <xsl:when test="1 &lt; $startnumber">
      <xsl:choose>
       <xsl:when test="0 &lt; string-length(substring-before($basenumber, '.'))">
        <xsl:value-of select="$startnumber -1 + number(substring-before($basenumber, '.'))"/><xsl:value-of select="concat('.', substring-after($basenumber, '.'))"/>
       </xsl:when>
       <xsl:otherwise>
        <xsl:value-of select="$startnumber -1 + number($basenumber)"/>
       </xsl:otherwise>
      </xsl:choose>
     </xsl:when>
     <xsl:otherwise>
      <xsl:value-of select="$basenumber"/>
     </xsl:otherwise>
    </xsl:choose>
    <xsl:text> </xsl:text>
    <xsl:apply-templates/>
   </xsl:element>
  </xsl:for-each>

  <div>
   <xsl:call-template name="docinfo"/>
  </div>
 </xsl:template>

<!-- ɥȾ -->
 <xsl:template name="docinfo">
  <xsl:for-each select="author/p">
   <xsl:apply-templates/><br/>
  </xsl:for-each>

  <xsl:for-each select="firstedition/p">
   <xsl:text>ǯ </xsl:text>
   <xsl:apply-templates/><br/>
  </xsl:for-each>

  <xsl:for-each select="lastmodified/p">
   <xsl:text>ǯ </xsl:text>
   <xsl:apply-templates/><br/>
  </xsl:for-each>

  <xsl:for-each select="copyright/p">
   <xsl:text> </xsl:text>
   <xsl:apply-templates/><br/>
  </xsl:for-each>
 </xsl:template>

 <xsl:template match="docgroup[@id]">
  <div id="{@id}"/>
  <xsl:apply-templates/>
 </xsl:template>

 <xsl:template match="p">
  <p><xsl:apply-templates/></p>
 </xsl:template>

</xsl:stylesheet>
